;
	Processor	16F84
;
       include <p16f84.inc>
;
_CP_OFF		EQU	H'3FFF'
_WDT_OFF	EQU	H'3FFB'
_XT_OSC		EQU	H'3FFD'
_ResetVector	EQU	H'0000'
_IntVector	EQU	H'0004'
;
;
	org	_ResetVector
    	goto	Start
;
	org	_IntVector
	retfie
count1	EQU	0ch
count2	EQU	0dh
count3	EQU	0eh
count4	EQU	0fh
alreg	EQU	10h
al	EQU	H'0000'
nred	EQU	H'0001'
counta1	EQU	11h
counta2	EQU	12h
counta3	EQU	13h
counta4	EQU	14h
corrvar	EQU	15h
testvar	EQU	16h

led_an	bcf	status,rp0
	bsf	portb,0
	retfie
nr_led	bcf	status,rp0
	btfsc	alreg,nred
	bsf	portb,0
	retfie
led_aus	bcf	status,rp0
	bcf	portb,0
	retfie
b4test	bcf	status,rp0
	btfss	corrvar,4
	call	wait6
	btfsc	corrvar,4
	bcf	corrvar,4
	retfie
b3test	bcf	status,rp0
	btfss	corrvar,3
	call	alarm
	btfsc	corrvar,3
	bcf	corrvar,3
	retfie
b2test	bcf	status,rp0
	btfss	corrvar,2
	call	alarm
	btfsc	corrvar,2
	bcf	corrvar,2
	retfie
portt0	bcf	status,rp0
	clrf	alreg
	btfsc	porta,4
	bsf	portb,0
	btfsc	porta,3
	bsf	portb,0
	btfsc	porta,2
	bsf	portb,0
	retfie
porttst	bcf	status,rp0
	btfsc	porta,4
	call	wait6
	btfsc	porta,3
	call	alarm
	btfsc	porta,2
	call	alarm
	retfie
setcvar	bcf	status,rp0
	movf	porta,0
	movwf	corrvar
	bsf	alreg,nred
	retfie
clcorr	bcf	status,rp0
	clrf	corrvar
	bcf	alreg,nred
	retfie
corrtst	bcf	status,rp0
	movf	corrvar,0
	subwf	porta,0
	btfsc	status,Z
	retfie
	movf	porta,0
	xorwf	corrvar,0
	movwf	testvar
	btfsc	testvar,4
	call	b4test
	btfsc	testvar,3
	call	b3test
	btfsc	testvar,2
	call	b2test
	movf	porta,0
	sublw	0x00
	btfsc	status,Z
	call	clcorr
	retfie
wait6	movlw	0x07		;30s
	movwf	counta4
schw3	movlw	0x0A		;1s
	movwf	counta3
schw2	movlw	0x81		;100ms
	movwf	counta2
schw1	movlw	0xFF		;766 M-Zyklen
	movwf	counta1		;255 nach count1
schw1i	decfsz	counta1,1	;abwrtszhlen, skip next falls 0
	goto	schw1i
schw2i	decfsz	counta2,1
	goto	schw1
	call	led_aus
	movlw	0x06
	subwf	counta3,0
	btfsc	status,Z
	call	led_an
schw3i	decfsz	counta3,1
	goto	schw2
	call	led_an
schw4i	decfsz	counta4,1
	goto	schw3
	call	alarm
	retfie

alarm	bsf	alreg,al
	call	led_an
scha4	movlw	0x3C		;30s
	movwf	counta4
scha3	movlw	0x04		;0,5s
	movwf	counta3
scha2	movlw	0xFF		;200ms
	movwf	counta2
scha1	movlw	0xFF		;766 M-Zyklen
	movwf	counta1		;255 nach count1
scha1i	decfsz	counta1,1	;abwrtszhlen, skip next falls 0
	goto	scha1i
scha2i	decfsz	counta2,1
	goto	scha1
	bcf	status,rp0
	bcf	portb,1
scha3i	decfsz	counta3,1
	goto	scha2
	bcf	status,rp0
	bsf	portb,1
scha4i	decfsz	counta4,1
	goto	scha3
	bcf	portb,1
	retfie

Start	clrf	alreg
	bcf	STATUS,RP1	;Aufwrtskompatibilitt
	bcf	STATUS,RP0	;Bank0 whlen
	clrf	INTCON		;Interrupts disablen
	clrf	PORTA		;Ports rcksetzen
	clrf	PORTB
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x1C
	movwf	TRISA		;Ra4..2 input Rest output
schl4	movlw	0x1E		;30s
	movwf	count4
schl3	movlw	0x0A		;1s
	movwf	count3
schl2	movlw	0x81		;100ms
	movwf	count2
schl1	movlw	0xFF		;766 M-Zyklen
	movwf	count1		;255 nach count1
schl1i	decfsz	count1,1	;abwrtszhlen, skip next falls 0
	goto	schl1i
schl2i	decfsz	count2,1
	goto	schl1
	call	led_aus
	movlw	0x06
	subwf	count3,0
	btfsc	status,Z
	call	portt0
schl3i	decfsz	count3,1
	goto	schl2
	call	led_an
schl4i	decfsz	count4,1
	goto	schl3

	movf	porta,0
	sublw	0x00
	btfss	status,Z
	call	setcvar

scharf	movlw	0x0A		;1s
	movwf	count3
schrf2	movlw	0x81		;100ms
	movwf	count2
schrf1	movlw	0xFF		;766 M-Zyklen
	movwf	count1		;255 nach count1
schrf1i	decfsz	count1,1	;abwrtszhlen, skip next falls 0
	goto	schrf1i
schrf2i	decfsz	count2,1
	goto	schrf1
	btfss	alreg,al
	call	led_aus
	btfss	alreg,nred
	call	porttst
	btfsc	alreg,nred
	call	corrtst
	movlw	0x08
	subwf	count3,0
	btfsc	status,Z
	call	nr_led
schrf3i	decfsz	count3,1
	goto	schrf2
	call	led_an
	goto	scharf

	END
