;
	Processor	16F84
;
       include <p16f84.inc>
;
_CP_OFF		EQU	H'3FFF'
_WDT_OFF	EQU	H'3FFB'
_XT_OSC		EQU	H'3FFD'
_ResetVector	EQU	H'0000'
_IntVector	EQU	H'0004'
;
;
	org	_ResetVector
    	goto	Start
;
	org	_IntVector
	retfie
count1	EQU	0ch
count2	EQU	0dh
count3	EQU	0eh
count4	EQU	0fh
alreg	EQU	10h
al0	EQU	H'0000'
al6	EQU	H'0002'
al	EQU	H'0004'
schn	EQU	H'0008'
nr	EQU	H'0010'
corrvar	EQU	11h

Start	clrf	alreg
	bcf	STATUS,RP1	;Aufwrtskompatibilitt
	bcf	STATUS,RP0	;Bank0 whlen
	clrf	INTCON		;Interrupts disablen
	clrf	PORTA		;Ports rcksetzen
	clrf	PORTB
	bsf	STATUS,RP0	;Bank1 whlen
	clrf	TRISB		;RB7..0 output
	movlw	0x1C
	movwf	TRISA		;Ra4..2 input Rest output

wait6	movlw	0x07		;30s
	movwf	count4
schw3	movlw	0x0A		;1s
	movwf	count3
schw2	movlw	0x81		;100ms
	movwf	count2
schw1	movlw	0xFF		;766 M-Zyklen
	movwf	count1		;255 nach count1
schw1i	decfsz	count1,1	;abwrtszhlen, skip next falls 0
	goto	schw1i
schw2i	decfsz	count2,1
	goto	schw1
	call	led_aus
	movlw	0x06
	subwf	count3,0
	btfsc	status,Z
	call	led_an
schl3i	decfsz	count3,1
	goto	schw2
	call	led_an
schl4i	decfsz	count4,1
	goto	schw3
	call	alarm

abbr	nop
	goto	abbr


alarm	bsf	alreg,al
scha4	movlw	0x3C		;30s
	movwf	count4
scha3	movlw	0x04		;0,5s
	movwf	count3
scha2	movlw	0xFF		;200ms
	movwf	count2
scha1	movlw	0xFF		;766 M-Zyklen
	movwf	count1		;255 nach count1
scha1i	decfsz	count1,1	;abwrtszhlen, skip next falls 0
	goto	scha1i
scha2i	decfsz	count2,1
	goto	scha1
	bcf	status,rp0
	bcf	portb,1
scha3i	decfsz	count3,1
	goto	scha2
	bcf	status,rp0
	bsf	portb,1
scha4i	decfsz	count4,1
	goto	scha3
	retfie

led_an	bcf	status,rp0
	bsf	portb,0
	retfie
led_aus	bcf	status,rp0
	bcf	portb,0
	retfie

	END
